#include "winmain1.cpp"
void WaveFill(HDC hdc,int xst, int yst);
void OneStep(HDC hdc, int *numSrc,int *numDest,POINT *Src,POINT*Dest);
void NearPix(HDC hdc, int x, int y, int *numStack, POINT *Stack);

void DrawStudyExample(HWND hWnd)
{
 HBRUSH hBrush, hBrushOld;
 HDC hdc;
  int xst,yst;
	hdc=GetDC(hWnd);
	if (hdc==NULL)return;
    hBrush=CreateSolidBrush(RGB(255,128,0));
	 hBrushOld=(HBRUSH)SelectObject(hdc,hBrush);
	Ellipse(hdc,50,50,200,150);
	xst=200-50;
	yst=150-50;
	WaveFill(hdc,xst,yst);
  ReleaseDC(hWnd,hdc);
  SelectObject(hdc,hBrushOld);
  DeleteObject(hBrush);
}

void WaveFill(HDC hdc,int xst, int yst)
{
 int numA,numB;
 POINT *stackA, *stackB;
 stackA=new POINT[10000];
 stackB=new POINT[10000];
 numA=1;
 stackA[0].x=xst;
 stackA[0].y=yst;
 numB=0;
 while(1)
  {
	if (numA>0)OneStep(hdc,&numA,&numB,stackA,stackB);
	else break;
	if (numB>0)OneStep(hdc,&numB,&numA,stackB,stackA);
	else break;
  }
  delete[]stackB;
  delete[]stackA;
}

void OneStep(HDC hdc, int *numSrc,int *numDest,POINT *Src,POINT*Dest)
{
 int x,y,i;
 *numDest=0;
 for(i=0;i<*numSrc;i++)
{ x=Src[i].x;
  y=Src[i].y;
  NearPix(hdc,x+1,y,numDest,Dest);
  NearPix(hdc,x-1,y,numDest,Dest);
  NearPix(hdc,x,y+1,numDest,Dest);
  NearPix(hdc,x,y-1,numDest,Dest);
 }
}

void NearPix(HDC hdc, int x, int y, int *numStack, POINT *Stack)
{
 if (GetPixel(hdc,x,y)!=0)
 {
  SetPixel(hdc,x,y,0);
  for (int e=0; e<1000; e++)
	for (int t=0; t<1000;t++)

  Stack[*numStack].x=x;
  Stack[*numStack].y=y;
  (*numStack)++;
 }
}

